<template>
<div :class="class_name" ref="cont" v-on:mouseover="onHover">
	<div v-if="!lobbies.length" class="no-lobbies" key="no-lobbies">
		<span v-if="filtered">No lobbies found</span>
		<span v-else>No lobbies are available</span>
	</div>
	<lobby-list-item
		v-for="lobby in lobbies"
		v-on:click="onItemClick"
		v-on:hover="onItemHover"
		:host="lobby.host"
		:id="lobby.id"
		:key="lobby.id"
		:max="lobby.max_players"
		:name="lobby.name"
		:players="lobby.player_count"
		:ref="'item' + lobby.id"
		:selected="selected_lobby === lobby.id"
	/>
</div>
</template>

<script>
import LobbyListItem from "./LobbyListItem.vue"

export default {
	components: { LobbyListItem },
	computed: {
		class_name: function () {
			return {
				"lobby-list": true,
				"selected": this.selected
			}
		}
	},
	created: function () {
		this.$on("PRESS_DOWN", function () {
			const index = this.getLobbyIndex()
			if (index < this.lobbies.length - 1) this.onItemHover(this.lobbies[index + 1].id)
		})
		this.$on("PRESS_UP", function () {
			const index = this.getLobbyIndex()
			if (index > 0) this.onItemHover(this.lobbies[index - 1].id)
		})
		this.$on("PRESS_ENTER", function () {
			this.onItemClick(this.selected_lobby)
		})
	},
	data: function () {
		return {
			focused: true,
			selected_lobby: this.lobbies.length ? this.lobbies[0].id : null
		}
	},
	methods: {
		getLobbyIndex: function () {
			return this.lobbies.findIndex((lobby) => {
				return lobby.id === this.selected_lobby
			})
		},
		onHover: function () {
			this.$emit("hover", this.id)
		},
		onItemClick: function (id) {
			this.$emit("join", this.lobbies.find((lobby) => {
				return lobby.id === id
			}).room_id)
		},
		onItemHover: function (id) {
			if (this.selected_lobby !== id) {
				UI.emit("PLAY_HOVER_SOUND")
				window.sel = this.$refs[`item${id}`][0]
				window.cont = this.$refs["cont"]

				cont.scrollTop = Math.min(cont.scrollTop, sel.$el.offsetTop)
				cont.scrollTop = Math.max(cont.scrollTop, sel.$el.offsetTop + sel.$el.offsetHeight - cont.offsetHeight)
			}
			this.selected_lobby = id
		}
	},
	name: "lobby-list",
	props: [ "filtered", "id", "lobbies", "selected" ],
	updated: function () {
		const that = this
		if (!this.lobbies.length) return
		if (!this.lobbies.find(function (lobby) {
			return lobby.id === that.selected_lobby
		})) {
			this.selected_lobby = this.lobbies[0].id
		}
	}
}
</script>

<style lang="less" scoped>
.lobby-list {
	background-color: #000;
	box-sizing: border-box;
	color: #fff;
	height: 18em;
	padding: .25em;
	overflow-y: scroll;
	text-shadow: none;
	width: 20em;

	&.selected {
		background-color: #333;
	}

	&::-webkit-scrollbar {
		width: .5em;
	}

	&::-webkit-scrollbar-track {
		background-color: #666;
	}

	&::-webkit-scrollbar-thumb {
		background-color: #aaa;
	}
}

.no-lobbies {
	align-items: center;
	display: flex;
	height: 100%;
	justify-content: center;
	width: 100%;
}
</style>
